api/urls.py
urlpatterns = [

]

fac/urls.py
from django.urls import path, include
from .views import ClienteView, ClienteNew, ClienteEdit, clienteInactivar, FacturaView, facturas, ProductoView

urlpatterns = [
    path("clientes/", ClienteView.as_view(), name="cliente_list"),
    path("clientes/new", ClienteNew.as_view(), name="cliente_new"),
    path("clientes/edit/<int:pk>", ClienteEdit.as_view(), name="cliente_edit"),
    path("clientes/estado/<int:id>", clienteInactivar, name="cliente_inactivar"),

    path("facturas/", FacturaView.as_view(), name="factura_list"),
    path("facturas/new", facturas, name="factura_new"),
    path("facturas/buscar-producto", ProductoView.as_view(), name="factura_producto"),
]

inv/urls.py
from django.urls import path

from inv.models import SubCategoria, UnidadMedida

from .views import CategoriaView, CategoriaNew, CategoriaEdit, CategoriaDel, MarcaView, \
    SubCategoriaView, SubCategoriaNew, SubCategoriaEdit, SubCategoriaDel, \
        MarcaView, MarcaNew, MarcaEdit, marca_inactivar, \
            UMView, UMNew, UMEdit, um_inactivar, \
                ProductoView, ProductoNew, ProductoEdit, producto_inactivar
            

urlpatterns = [
    path('categorias/', CategoriaView.as_view(), name='categoria_list'),
    path('categorias/new', CategoriaNew.as_view(), name='categoria_new'),
    path('categorias/edit/<int:pk>', CategoriaEdit.as_view(), name='categoria_edit'),
    path('categorias/delete/<int:pk>', CategoriaDel.as_view(), name='categoria_del'),

    path('subcategorias/', SubCategoriaView.as_view(), name='subcategoria_list'),
    path('subcategorias/new', SubCategoriaNew.as_view(), name='subcategoria_new'),
    path('subcategorias/edit/<int:pk>', SubCategoriaEdit.as_view(), name='subcategoria_edit'),
    path('subcategorias/delete/<int:pk>', SubCategoriaDel.as_view(), name='subcategoria_del'),

    path('marcas/', MarcaView.as_view(), name='marca_list'),
    path('marcas/new', MarcaNew.as_view(), name='marca_new'),
    path('marcas/edit/<int:pk>', MarcaEdit.as_view(), name='marca_edit'),
    path('marcas/inactivar/<int:id>', marca_inactivar, name='marca_inactivar'),

    path('um/', UMView.as_view(), name='um_list'),
    path('um/new', UMNew.as_view(), name='um_new'),
    path('um/edit/<int:pk>', UMEdit.as_view(), name='um_edit'),
    path('um/inactivar/<int:id>', um_inactivar, name='um_inactivar'),

    path('producto/', ProductoView.as_view(), name='producto_list'),
    path('producto/new', ProductoNew.as_view(), name='producto_new'),
    path('producto/edit/<int:pk>', ProductoEdit.as_view(), name='producto_edit'),
    path('producto/inactivar/<int:id>', producto_inactivar, name='producto_inactivar'),    
]

syscofa/urls.py
from argparse import Namespace
from django.contrib import admin
from django.urls import path, include

urlpatterns = [
    path('', include(('bases.urls', 'bases'), namespace='bases')),
    path('inv/', include(('inv.urls', 'inv'), namespace='inv')),
    path('cmp/', include(('cmp.urls', 'cmp'), namespace='cmp')),
    path('fac/', include(('fac.urls', 'fac'), namespace='fac')),
    path('api/', include(('api.urls', 'api'), namespace='api')),
    path('admin/', admin.site.urls),
    path('api-auth/', include('rest_framework.urls')),    
]

fac/models.py
from tabnanny import verbose
from tkinter import CASCADE
from django.db import models

from bases.models import ClaseModelo, ClaseModelo2
from inv.models import Producto

# Create your models here.
class Cliente(ClaseModelo):
    """ modelo que representa un cliente """
    #example of choices
    NAT = 'Natural'
    JUR = 'Jurídica'
    TIPO_CLIENTE = [
        (NAT, 'Natural'),
        (JUR, 'Jurídica')
    ]

    nombres = models.CharField(
        max_length=100
    )

    apellidos = models.CharField(
        max_length=100
    )
    celular = models.CharField(
        max_length=20,
        null=True,
        blank=True
    )

    tipo = models.CharField(
        max_length=10,
        choices=TIPO_CLIENTE,
        default=NAT
    )

    def __str__(self):
        return '{} {}'.format(self.apellidos, self.nombres)

    def save(self):
        self.nombres = self.nombres.upper()
        self.apellidos = self.apellidos.upper()
        super(Cliente, self).save()

    class Meta:
        verbose_name_plural = 'Clientes'

class FacturaEnc(ClaseModelo2):
    cliente = models.ForeignKey(Cliente, on_delete=models.CASCADE)
    fecha = models.DateTimeField(auto_now_add=True)
    sub_total = models.FloatField(default=0)
    descuento = models.FloatField(default=0)
    total = models.FloatField(default=0)

    def __str__(self):
        return '{}'.format('id')

    def save(self):
        self.total = self.sub_total - self.descuento
        super(FacturaEnc, self).save()

    class Meta:
        verbose_name_plural = "Encabezado Facturas"
        verbose_name = "Encabezado Factura"

class FacturaDet(ClaseModelo2):
    factura = models.ForeignKey(FacturaEnc, on_delete=models.CASCADE)
    producto = models.ForeignKey(Producto, on_delete=models.CASCADE)
    cantidad = models.BigIntegerField(default=0)
    precio = models.FloatField(default=0)
    sub_total = models.FloatField(default=0)
    descuento = models.FloatField(default=0)
    total = models.FloatField(default=0)

    def __str__(self):
        return '{}'.format(self.producto)

    def save(self):
        self.sub_total = float(float(int(self.cantidad)) * float(self.precio))
        self.total = self.sub_total - float(self.descuento)
        super(FacturaDet, self).save()

    class Meta:
        verbose_name_plural = "Detalles Facturas"
        verbose_name = "Detalle Factura"

fac/forms.py
from django import forms
from .models import Cliente

class ClienteForm(forms.ModelForm):
    """Form definition for Cliente."""

    class Meta:
        """Meta definition for Clienteform."""
        model = Cliente
        fields = ['nombres', 'apellidos', 'tipo', 'celular', 'estado']
        exclude = ['um', 'fm', 'uc', 'fc']

    def __init__(self, *args, **kwargs):
        super().__init__(*args, **kwargs)
        #iteramos todos los campos del form
        for field in iter(self.fields):
            self.fields[field].widget.attrs.update({
                'class': 'form-control'
            })

    

fac/views.py
from multiprocessing import context
from operator import inv
from django.http import HttpResponse
from django.shortcuts import render
from django.urls import reverse_lazy
from django.views import generic
from django.contrib.auth.decorators import login_required, permission_required
from datetime import datetime

from bases.views import Sin_Privilegios, VistaBaseCreate, VistaBaseEdit
from .models import Cliente, FacturaEnc
from .forms import ClienteForm
from inv import views as inv

# Create your views here.
class ClienteView(Sin_Privilegios, generic.ListView):
    model = Cliente
    template_name = "fac/cliente_list.html"
    context_object_name = "obj"
    permission_required = "fac/view_cliente"

class ClienteNew(VistaBaseCreate):
    model = Cliente
    template_name = "fac/cliente_form.html"
    form_class = ClienteForm
    success_url = reverse_lazy('fac:cliente_list')
    permission_required = 'fac.add_cliente'

class ClienteEdit(VistaBaseEdit):
    model = Cliente
    template_name = "fac/cliente_form.html"
    form_class = ClienteForm
    success_url = reverse_lazy("fac:cliente_list") 
    permission_required = 'fac.change_cliente'

@login_required(login_url='/login/') #necesitamos estar logeados
@permission_required("fac:change_cliente", login_url='/login/') #permiso requerido
def clienteInactivar(request, id):
    cliente = Cliente.objects.filter(pk=id).first()

    if request.method == "POST":
        if cliente: # si se creo el cliente
            #si cliente esta en true se cambia a false o viceversa
            cliente.estado = not cliente.estado 
            cliente.save()
            return HttpResponse("OK")
        return HttpResponse("FAIL")

    return HttpResponse("FAIL")
    
class FacturaView(Sin_Privilegios, generic.ListView):
    model = FacturaEnc
    template_name = "fac/factura_list.html"
    context_object_name = "obj"
    permission_required = 'fac.view_facturaenc'

@login_required(login_url='/login/') #necesitamos estar logeados
@permission_required("fac:change_facturaenc", login_url='bases:sin_privilegios') #permiso requerido
def facturas(self):
    template_name = "fac/facturas.html"
    encabezado = {
        'fecha': datetime.today()
    }
    detalle = {}
    clientes = Cliente.objects.filter(estado=True)

    contexto = {"enc":encabezado, "det":detalle, "clientes":clientes}
    
    return render(self, template_name, contexto)

class ProductoView(inv.ProductoView):
    template_name = "fac/buscar_producto.html"


# class ClienteNew(SuccessMessageMixin, Sin_Privilegios, generic.CreateView):
#     model = Cliente
#     template_name = "fac/cliente_form.html"
#     context_object_name = "obj"
#     form_class = ClienteForm
#     success_url = reverse_lazy('fac:cliente_list')
#     permission_required = 'fac.add_cliente'
#     success_message = "Cliente creado satisfactoriamente"

#     def form_valid(self, form):
#         form.instance.uc = self.request.user #ubicamos al usuario que creo el formulario
#         return super().form_valid(form)

# class ClienteEdit(SuccessMessageMixin, Sin_Privilegios, generic.UpdateView):
#     model = Cliente
#     template_name = "fac/cliente_form.html"
#     context_object_name = "obj"
#     form_class = ClienteForm
#     success_url = reverse_lazy("fac:cliente_list") 
#     permission_required = 'fac.change_cliente'
#     success_message = "Cliente actualizado satisfactoriamente"

#     def form_valid(self, form):
#         form.instance.um = self.request.user.id #ubicamos al usuario que editó el formulario
#         return super().form_valid(form)

fac/templates/fac/cliente_form.html
<div class="modal-dialog modal-lg">  
    <div class="modal-content">
        
        {% if obj %}        
            <form method="POST" role="form" class="form-inline" action="{% url 'fac:cliente_edit' obj.pk %}">
        {% else %}
            <form method="POST" role="form" class="form-inline" action="{% url 'fac:cliente_new' %}">
        {% endif %}    

            {% csrf_token %}
            <div class="col-xl-12 col-md-12 mb-12">
    
                {% if obj %}
                <div class="card border-left-warning shadow h-100 py-2">
                    {% else %}
                    <div class="card border-left-succes shadow h-100 py-2">
                        {% endif %}
                        <div class="card-body">
                            <div class="row no-gutters align-items-center">
                                <div class="col mr-2">
                                    <div class="text-xs font-weight-bold text-primary text-uppercase mb-1">
                                        {% if obj %} Editar {% else %} Nuevo {% endif %}Cliente
                                    </div>
                                    <div class="dropdown-divider"></div>
                                    <div class="row">
                                        {{ form.as_p}}
                                    </div>
    
                                    <!-- {{ form.as_p }} -->
                                    <div class="dropdown-divider"></div>
                                    <div class="row">
                                        <div class="col">
                                            <button type="submit" class="btn btn-danger"><span class="fa fa-save"></span>Guardar</button>
                                            <!-- <a href="{% url 'inv:um_list' %}" class="btn btn-success"><span class="fa fa-undo">Cancelar</span></a> -->
                                            <button type="button" class="btn btn-success" onclick="return cerrar_modal()">Cancelar</button>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
        </form>
    </div>        
</div>

fac/templates/fac/cliente_list.html
{% extends 'base/base.html' %}

{% block page_content %}
 <!-- Dropdown Card Example -->
 <div class="card shadow mb-4">
    <!-- Card Header - Dropdown -->
    <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
        <h6 class="m-0 font-weight-bold text-primary">Listado de Clientes</h6>
        <div class="dropdown no-arrow">
            <a class="dropdown-toggle" href="#" role="button" id="dropdownMenuLink" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                <i class="fas fa-ellipsis-v fa-sm fa-fw text-gray-400"></i>
            </a>
            <div class="dropdown-menu dropdown-menu-right shadow animated--fade-in" aria-labelledby="dropdownMenuLink">
                <div class="dropdown-header">Acciones:</div>
                    <a class="dropdown-item" onclick="return abrir_modal('{% url 'fac:cliente_new' %}')"> <i class="far fa-calendar-plus"></i> Nuevo</a>
                    <!-- <a class="dropdown-item" href="#">Another action</a> -->
                <div class="dropdown-divider"></div>
                <!-- <a class="dropdown-item" href="#">Something else here</a> -->
            </div>
        </div>
    </div>
    <!-- Card Body -->
    <div class="card-body">
       
       {% if not obj %}
            <div class="alert alert-info">No Hay Clientes</div>           
       {% endif %}
       <!-- <div class="buttons-toolbar">
            <button type="button" class="btn btn-primary" onclick="return abrir_modal('{% url 'fac:cliente_new' %}')"><i class="far fa-calendar-plus">Nuevo</i></button>
       </div> -->

       <table
            id="table"
            data-toggle="table"
            data-pagination="true"
            data-page-size="5"
            data-search="true"
            data-show-columns="true"
            data-show-fullscreen="true"
            data-show-toggle="true"
            data-show-export="true"
            data-click-to-select="true"
            data-locale="es-MX"
        >
           <thead>
               <th data-field="id" data-sortable="true">Id</th>
               <th data-field="nombres" data-sortable="true">Nombres</th>
               <th data-field="apellidos" data-sortable="true">Apellidos</th>
               <th>Celular</th>
               <th data-field="tipo" data-sortable="true">Tipo</th>
               <th>Estado</th>                                  
               <th class="all">Acciones</th>
           </thead>

           <tbody>               
               {% for item in obj %}
                   <tr>
                       <td>{{ item.id }}</td>
                       <td>{{ item.nombres }}</td>
                       <td>{{ item.apellidos }}</td>
                       <td>{{ item.celular }}</td>
                       <td>{{ item.tipo }}</td>                                          
                       <td>{# item.estado|yesno:"Activo,Inactivo" #}
                            <div onclick="inactivar({{ item.id }})">
                                <!-- si el cliente esta activo -->
                                {% if item.estado %} 
                                    <i class="far fa-thumbs-up text-primary"></i>
                                {% else %}
                                    <i class="far fa-thumbs-down text-danger"></i>
                                {% endif %}
                            </div>      
                       </td>
                       <td>
                            <button class="btn btn-warning btn-circle" onclick="return abrir_modal('{% url 'fac:cliente_edit' item.id %}')"><i class="far fa-edit"></i></button>
                       </td>
                   </tr>
               {% endfor %}
                   
           </tbody>
       </table>       

    </div>
</div>

{% endblock page_content %}

{% block js_page %}

    <script>

        // Jquery para inactivar cliente
        function inactivar(id){
            var data = {id:id};
            data = JSON.stringify(data);
            var token = '{{csrf_token}}';
            // alert(token);
            // alert(id);            

            $.ajax({
                headers: {'X-CSRFToken': token},
                type: "POST",
                url: "estado/"+id,
                data: data,
                success: function(response){
                    if(response == "OK"){
                        location.reload(true);
                    }else{
                        mensaje("Error Intentando Cambiar Estado a Cliente");
                    }
                },
                error: function(jqXHR, textStatus, errorThrow){
                    console.log(textStatus, errorThrow);
                    mensaje(errorThrow, 'red');
                    cerrar_modal();
                }
            });

        }

        var $table = $('#table')

        $(function() {
            $('#toolbar').find('select').change(function () {
            $table.bootstrapTable('destroy').bootstrapTable({
                exportDataType: $(this).val(),
                exportTypes: ['json', 'xml', 'csv', 'txt', 'sql', 'excel', 'pdf'],
                columns: [
                {
                    field: 'state',
                    checkbox: true,
                    visible: $(this).val() === 'selected'
                },
                {
                    field: 'id',
                    title: 'ID'
                }, {
                    field: 'name',
                    title: 'Item Name'
                }, {
                    field: 'price',
                    title: 'Item Price'
                }
                ]
            })
            }).trigger('change')
        })

        // llamamos el dataTables jQuery plugin
        // $(function() {
        //     $("#sidebarToggle").click();
        //     $('.table').DataTable({
        //         "language": {
        //             "processing": "Procesando...",
        //             "lengthMenu": "Mostrar _MENU_ registros",
        //             "zeroRecords": "No se encontraron resultados",
        //             "emptyTable": "Ningún dato disponible en esta tabla",
        //             "infoEmpty": "Mostrando registros del 0 al 0 de un total de 0 registros",
        //             "infoFiltered": "(filtrado de un total de _MAX_ registros)",
        //             "search": "Buscar:",
        //             "infoThousands": ",",
        //             "loadingRecords": "Cargando...",
        //             "paginate": {
        //                 "first": "Primero",
        //                 "last": "Último",
        //                 "next": "Siguiente",
        //                 "previous": "Anterior"
        //             },
        //             "aria": {
        //                 "sortAscending": ": Activar para ordenar la columna de manera ascendente",
        //                 "sortDescending": ": Activar para ordenar la columna de manera descendente"
        //             }
        //         }
        //     });
        // });
    </script>
    
{% endblock js_page%}
    

fac/templates/fac/facturas.html
{% extends 'base/base.html' %}


{% block page_content %}
    <div class="card shadow mb-4">
        <div class="card-header py-3 d-flex flex-row align-items-center justify-content-between">
            <a href="#" class="btn btn-danger">Guardar</a>
            <a href="#" class="btn btn-success">Imprimir</a>
            <a href="{% url 'fac:factura_list' %}" class="btn btn-info">Cancelar</a>
        </div>

        <div class="card-body">
            <div class="content">
                <!-- sección superior -->
                <div class="row">
                    <!-- sección izquierda -->
                    <div class="col-lg-6">
                        <div class="content">
                            <div class="row">
                                <div class="col-lg-1">No.</div>
                                <div class="col-lg-4">
                                    <input type="text" name="enc_id" id="enc_id" readonly class="form-control">
                                </div>
                                <div class="col-lg-2">Cliente</div>
                                <!-- uso del select -->
                                <div class="col-lg-5 form-group">
                                    <select name="enc_cliente" id="enc_cliente">
                                        <option value="0">Seleccione Cliente</option>
                                        
                                        {% for item in clientes %}
                                            <option value="{{ item.id }}">{{ item.nombres }} {{ item.apellidos }}</option>
                                        {% endfor %}
                                            
                                    </select>
                                </div>
                            </div>

                            <div class="row">
                                <div class="col-lg-6 p-2" >
                                    <div class="row">
                                        <div class="col-lg-2">
                                            Fecha:
                                        </div>
                                        <div class="col-lg-8 form-group">
                                            <input type="text" name="fecha" id="fecha" class="form-control form-control-user" 
                                            value="{{ enc.fecha|date:'Y-m-d' }}" readonly />
                                        </div>
                                    </div>
                                </div>
                                <div class="col-lg-6 p-2 form-group">
                                    <div class="row">
                                        <div class="col-lg-3">Sub Total:</div>
                                        <div class="col-lg-8">
                                            <input type="number" class="form-control text-right" value="0.00" readonly
                                            name="sub_total" id="sub_total">
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-lg-3">Descuento:</div>
                                        <div class="col-lg-8">
                                            <input type="number" class="form-control text-right" value="0.00" disabled
                                                name="descuento" id="descuento">
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-lg-3">Total:</div>
                                        <div class="col-lg-8">
                                            <input type="number" class="form-control text-right" value="0.00" disabled
                                                name="total" id="total">
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                    <!-- fin sección izquierda -->

                <!-- Sección Derecha -->
                <div class="col-lg-6 from-group">
                    <div class="row p-2">
                        <div class="col-lg-1">Cod</div>
                        <div class="col-lg-3">
                            <input type="text" class="form-control" name="codigo" id="codigo" placeholder="Cód. Producto">
                        </div>
                        <div class="col-lg-7">
                            <input type="text" class="form-control" name="descripcion" id="descripcion" placeholder="Descripción" disabled>
                        </div>
                        <div class="col-lg-1">
                            <button type="button" class="btn btn-info" id="btnBuscar">
                                <i class="fab fa-searchengin"></i>
                            </button>
                        </div>
                    </div>
                    <div class="row">
                        <div class="col-lg-1">Cant</div>
                        <div class="col-lg-3">
                            <input type="number" class="form-control" name="cantidad" id="cantidad" placeholder="Cantidad">
                            <input type="hidden" class="form-control" name="existencia" id="existencia">
                        </div>
                        <div class="col-lg-4">
                            <input type="number" class="form-control" name="precio" id="precio" placeholder="Precio" readonly>
                        </div>
                        <div class="col-lg-3">
                            <input type="number" class="form-control" name="descuento_detalle" id="descuento_detalle" placeholder="Descuento">
                        </div>
                        <div class="col-lg-1">
                            <button type="submit" class="btn btn-danger" id="btnGuardar"> <i class="far fa-plus-square"></i> </button>
                        </div>
                    </div>
                    <div class="row p-1">
                        <div class="col-lg-9 text-right">Sub Total</div>
                        <div class="col-lg-3">
                            <input type="number" class="form-control" name="sub_total_detalle" id="sub_total_detalle" placeholder="Sub Total"
                             value="0.00" disabled>
                        </div>
                    </div>
                    <div class="row p-1">
                        <div class="col-lg-9 text-right">Total</div>
                        <div class="col-lg-3">
                            <input type="number" class="form-control" name="total_detalle" id="total_detalle" placeholder="Total"
                             value="0.00" disabled>
                        </div>
                    </div>
                </div>
                <!-- Fin Sección Derecha -->
            </div>
            <!-- Fin Sección Superior -->

            <!-- Inicio Detalle -->
            <hr>
            <div class="row p-1">
                <div class="col-lg-12">
                    <table
                        data-toggle="table"
                        data-pagination="true"
                        data-search="true"
                        data-show-columns="true"
                        data-show-toggle="true"
                        data-show-fullscreen="true"
                        data-locale="es-MX"
                        >
                        <thead>
                            <th data-sortable="true" data-field="id">Id.</th>        
                            <th data-sortable="true" data-field="codigo">Código</th>
                            <th data-sortable="true" data-field="descripcion">Descripción</th>
                            <th data-field="cantidad">Cant</th>
                            <th data-field="subtotal">S. Total</th>
                            <th data-field="descuento">Des.</th>
                            <th data-field="total">Total</th>
                            <th class="all">Acciones</th>
                        </thead>
                        <tbody>
                            {% for item in det%}
                            <tr>
                                <td>{{ item.id }}</td>
                                <td>{{ item.producto }}</td>
                                <td>{{ item.producto.descripcion }}</td>
                                <td>{{ item.cantidad }}</td>
                                <td>{{ item.sub_total }}</td>
                                <td>{{ item.descuento }}</td>
                                <td>{{ item.total }}</td>
                            <td>
                                <button type="button" class="btn btn-warning btn-circle"
                                    onclick="borrar_detalle({{ item.id }})">
                                    <i class="fas fa-history"></i>
                                </button>
                            </td>
                            </tr>
                            {% endfor %}
                        </tbody>
                    </table>
                </div>
            </div>
            <!-- Fin Detalle -->
        </div>
    </div>
{% endblock page_content %}


{% block js_page %}
    <script>
        $(function (){
            $("sidebarToggle").click();
            $("#enc_cliente").select2({
                placeholder:"Seleccione Cliente",
                allowClear:true
            });

            // acción de botón buscar
            $("#btnBuscar").click(function(e){
                // se valida si no hay nada seleccionado
                if($("#enc_cliente").val() === "0"){
                    mensaje("Cliente no seleccionado", "red");
                    return false;
                }
                abrir_modal("{% url 'fac:factura_producto' %}");
            });
        });
    </script>
{% endblock js_page %}
    
    